<?php
  include_once('plugin_class_root.inc.php');
  include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes/public_integration.class.inc.php');


  /* classe mypolls pour la partie publique */
  class fo_mypolls extends root_mypolls
  {
    var $menubar; //to manage a specific 'mypolls' menubar

    function fo_mypolls($prefixeTable, $filelocation)
    {
      parent::root_mypolls($prefixeTable, $filelocation);

      $this->menubar=new public_integration($this->section_name);
    }

    /*
      load language file
    */
    function load_lang()
    {
      global $lang;

      include_once(get_language_filepath('plugin.lang.php',MYPOLLS_PATH));
    }

    /*
      initialize events
        - template's menu
        - callbacks to function displaying mypolls pages
        - callbacks to function making mypolls menu
        - initialize events
    */
    function init_events()
    {
      parent::init_events();      
      $this->load_config();
      $this->menubar->set_menu_tpl("
        <!-- BEGIN mypolls -->
        <dl id=\"mbMyPolls\">
        <dt>{mypolls.TITLE}</dt>
        <dd><ul>
        <!-- BEGIN link -->
        <li><a href=\"{mypolls.link.URL}\">{mypolls.link.LABEL}</a></li>
        <!-- END link -->
        </ul></dd></dl>
        <!-- END mypolls -->");

      $this->menubar->set_callback_page_function(array(&$this, 'manage_page'));
      $this->menubar->set_callback_init_menu_function(array(&$this, 'manage_menu'));
      $this->menubar->init_events();
      add_event_handler('loading_lang', array(&$this, 'load_lang'));
    }

    function extract_poll_id_from_uri()
    {
      $poll_id=explode($this->section_name.'/', $_SERVER['REQUEST_URI']);
      $poll_id=explode('&', $poll_id[1]);

      return($poll_id[0]);
    }

    /* -------------------------------------------------------------------------
      FUNCTIONS TO MANAGE POLL'S VOTES
    ------------------------------------------------------------------------- */

    /*
      analyse formated string "fq_N_a_M_P"
      return an array(N,M,P)
    */
    function analyse_answer($answer)
    {
      $tmp=explode("_",$answer);
      if(!isset($tmp[4]))
      { $tmp[4]=1; }
      $return=array($tmp[1],$tmp[3],$tmp[4]);
      return($return);
    }

    /*
      do vote
      return true if Ok, else a number
        -1 : database problem
        -2 : user has already vote
        -3 : ip has already vote
    */
    function do_vote($poll_id, $vote_results, $vote_comment, $user_id, $ip, $lang)
    {
      $vote_resultsa=unserialize(stripslashes($vote_results));

      if($user_id==2) { $vote_id = $ip; } else { $vote_id = $user_id; }
      $sql='INSERT INTO '.$this->tables['polls_votes']."
            VALUES ('".$poll_id."',
                    '".$vote_id."',
                    '".date('Y-m-d H:i:s')."',
                    '".htmlspecialchars(stripslashes($vote_comment), ENT_QUOTES)."')";
      if(pwg_query($sql))
      {
        $sql="UPDATE ".$this->tables['polls']."
              SET total_votes = total_votes + 1,
                  last_vote = '".date('Y-m-d H:i:s')."',
                  visit_without_vote = visit_without_vote - 1";
        if($vote_comment!="")
        {
          $sql.=", nb_comments = nb_comments + 1 ";
        }
        $sql.=" WHERE id = '".$poll_id."' ";
        if(pwg_query($sql))
        {
          foreach($vote_resultsa as $key => $val)
          {
            $nb_votes=0;
            //first, updating "nb_votes, used for ordering result and apply frequency
            foreach($val as $key2 => $val2)
            {
              $vote_result=$this->analyse_answer($val2);
              $sql="UPDATE ".$this->tables['polls_answers']."
                    SET nb_votes = nb_votes + ".$vote_result[2]."
                    WHERE id_poll = '".$poll_id."'
                      AND id_question = '".$vote_result[0]."'
                      AND answer_num = '".$vote_result[1]."'; ";
              $result=pwg_query($sql);

              $sql="UPDATE ".$this->tables['polls_answers_lang']."
                    SET nb_votes = nb_votes + ".$vote_result[2]."
                    WHERE id_poll = '".$poll_id."'
                      AND id_question = '".$vote_result[0]."'
                      AND id_answer = '".$vote_result[1]."'
                      AND lang = '".$lang."' ";
              $result=pwg_query($sql);
              $nb_votes+=$vote_result[2];
            }
            //"nb_votes" updated, reload order and apply frequency
            $question_num=$vote_result[0];
            $poll_answers=$this->get_poll_answers($poll_id, $question_num, $lang, " nb_votes ASC, ans_order ASC", true);
            $num=0;
            foreach($val as $key2 => $val2)
            {
              $vote_result=$this->analyse_answer($val2);
              if($vote_result[2]!=$poll_answers[$vote_result[1]]['order'])
              {
                $sql="UPDATE ".$this->tables['polls_answers']."
                      SET frequency = frequency + 1,
                          ans_order = '".$poll_answers[$vote_result[1]]['order']."'
                      WHERE id_poll = '".$poll_id."'
                      AND id_question = '".$vote_result[0]."'
                      AND answer_num = '".$vote_result[1]."'; ";
                $result=pwg_query($sql);
              }
              else
              {
                $sql="UPDATE ".$this->tables['polls_answers']."
                      SET ans_order = '".$poll_answers[$vote_result[1]]['order']."'
                      WHERE id_poll = '".$poll_id."'
                      AND id_question = '".$vote_result[0]."'
                      AND answer_num = '".$vote_result[1]."'; ";
                $result=pwg_query($sql);
              }
            }

            $sql="UPDATE ".$this->tables['polls_questions']."
                  SET nb_votes = nb_votes + ".$nb_votes."
                  WHERE id_poll = '".$poll_id."'
                    AND question_num = '".$vote_result[0]."' ;";
            $result=pwg_query($sql);
          }
        }
      }
    }

    /*
      looks if user/ip has already make a vote
        return true if yes, else false
    */
    function get_user_already_vote($poll_id, $user_id, $ip)
    {
      $sql="SELECT user_id FROM ".$this->tables['polls_votes']."
            WHERE poll_id = '".$poll_id."'
              AND user_id = '".$ip."'
            UNION
            SELECT user_id FROM ".$this->tables['polls_votes']."
            WHERE poll_id = '".$poll_id."'
              AND user_id = '".$user_id."'";
      $result=pwg_query($sql);
      if($result)
      {
        if(mysql_num_rows($result)>0) 
        { return(true); }
      }
      return(false);
    }

    /*
      count visit on vote's page
      $step=
        'before' = before vote
        'after' = after vote
    */
    function count_visit($poll_id, $step)
    {
      $field=array('before' => 'visit_without_vote', 'after' => 'visit_after_vote');
      $sql="UPDATE ".$this->tables['polls']."
            SET ".$field[$step]." = ".$field[$step]." + 1
            WHERE id = '".$poll_id."'";
      pwg_query($sql);
    }
  
    /*
      return user's group as an array
    */
    function get_user_groups($user_id)
    {
      $returned=array();
      $sql="SELECT group_id FROM ".USER_GROUP_TABLE."
            WHERE user_id = ".$user_id." ";
      $result=pwg_query($sql);
      if($result)
      {
        while($row=mysql_fetch_assoc($result))
        {
          array_push($returned, $row['group_id']);
        }
      }
      return($returned);
    }

    /* -------------------------------------------------------------------------
      FUNCTIONS TO MANAGE POLL'S DISPLAY
    ------------------------------------------------------------------------- */

    /*
      display mypolls page ; no parameters, all is in $_REQUEST
      this function is a called by a menubar's callback only when it is necessary
    */
    function display_page($poll_id)
    {
      global $template, $user;

      $poll_values=$this->get_poll_values($poll_id, $user['language']);
      if(!$poll_values)
      {
        page_not_found('This page does not exist', 'index.php?');
        return(false);
      }

      $users = new users($poll_values['allowed_users']);
      $groups = new groups($poll_values['allowed_groups']);


      $user_groups=$this->get_user_groups($user['id']);
/*$tmp=array(true => 'y', false => 'n');
echo $tmp[$users->is_allowed($user['status'])]."--".$user['status']."--".$users->get_alloweds('id')."--".$poll_values['allowed_users']."<br>";
echo $tmp[$groups->are_allowed($user_groups)]."--".serialize($user_groups)."--".$poll_values['allowed_groups']."<br>";*/

      //looks if user/group is allowed to access page
      if((!$users->is_allowed($user['status']) ||
         (($poll_values['allowed_groups']!='') && !$groups->are_allowed($user_groups))) &&
         !is_admin())
      {
        page_not_found('User not allowed', 'index.php?');
      }

      if($user['id']!=2)
      {
        $generic_text=$this->my_config['mypolls_generic_text_users'][$user['language']];
      }
      else
      {
        $generic_text=$this->my_config['mypolls_generic_text_guests'][$user['language']];
      }

      $template->assign_var('TITLE', $poll_values['title']);
      $template->assign_var('PLUGIN_INDEX_ACTIONS' , 
                '<li><a href="'.make_index_url().'" title="'.l10n('return to homepage').'">
                  <img src="'.$template->themeconf['icon_dir'].'/home.png" class="button" alt="'.l10n('home').'"/></a></li>');

      if (is_admin())
      {
        $template->assign_block_vars('edit',
          array('URL' => PHPWG_ROOT_PATH.$this->page_link."&amp;f_tabsheet=polls&amp;action=modify&amp;fmypolls_att_id=".$poll_id)
        );
      }

      //displayed nfo even if results are not public
      $template->assign_var('MYPOLLS_DESCRIPTION', html_entity_decode($poll_values['description'], ENT_QUOTES));
      if($generic_text!='')
      {
        $template->assign_block_vars(
          'mypolls_generic_text',
          array('GENERIC_TEXT' => $generic_text)
        );
      }
      

      if(!$this->get_user_already_vote($poll_id, $user['id'], $_SERVER['REMOTE_ADDR']))
      {
        // no vote for this poll by user, display poll in 'vote' mode

        //count visit on page
        $this->count_visit($poll_id, 'before');
        $first_question=array('mono' => 0, 'multi' => 1);

        $template->set_filename('body_page', dirname($this->filelocation).'/templates/mypolls_public_question.tpl');

        $template->assign_vars(
          array(
            'MYPOLLS_ATT_ID' => $poll_id,
            'MYPOLLS_AJAX_URL_POLL_DETAIL' => './index.php?/'.$this->section_name.'/'.$poll_id.'&ajaxfct=poll_question_blocks',
            'MYPOLLS_LANG' => $user['language'],
            'MYPOLLS_FIRST_QUESTION' => $first_question[$poll_values['display_type']],
            'MYPOLLS_NBQUESTIONS' => $poll_values['nb_questions'],
            'MYPOLLS_CHARSET' => substr($user['language'], 6)
          )
        );
      }
      else
      {
        //user/ip have already voted
        $template->set_filename('body_page', dirname($this->filelocation).'/templates/mypolls_public_results.tpl');

        $template->assign_block_vars(
          'mypolls_after_vote_text',
          array('TEXT' => html_entity_decode($poll_values['after_vote_text'], ENT_QUOTES))
        );

        if($poll_values['public_results']=='n')
        {
          $not_public_text=html_entity_decode($this->my_config['mypolls_not_public_results'][$user['language']]);
          if($not_public_text=="")
          {
            $not_public_text=l10n('mypolls_not_public_results');
          }
          $template->assign_block_vars(
            'mypolls_not_public_results', array("TEXT" => $not_public_text)
          );
        }
        else
        {
          if($poll_values['show_comments']=='y')
          {
            $template->assign_block_vars(
              "view_comments",
              array(
                "MYPOLLS_CHARSET" => substr($user['language'], 6),
                "MYPOLLS_AJAX_URL_POLL_COMMENT_LIST" => './index.php?/'.$this->section_name.'/'.$poll_id.'&ajaxfct=poll_comment_list&vpage=',
              )
            );
          }


          $this->display_results_block($poll_id, $user['language'], $poll_values);
        }

        //count visit on page
        $this->count_visit($poll_id, 'after');
      }


      unset($template->_tpldata['mode_posted.']);
      unset($template->_tpldata['mode_created.']);
      $template->assign_var_from_handle('PLUGIN_INDEX_CONTENT_BEGIN', 'body_page');
    }

    /*
      analyse uri request, do vote and load the page
    */
    function manage_page()
    {
      global $page, $user;

      $this->load_lang();

      if($page['section'] == $this->section_name)
      {
        $poll_id=$this->extract_poll_id_from_uri();
        
        if((isset($_POST['submit_results']))&&(!$this->get_user_already_vote($poll_id, $user['user_id'], $_SERVER['REMOTE_ADDR'])))
        {
          if(!isset($_REQUEST['fmypolls_comment']))
          { $_REQUEST['fmypolls_comment']=''; }
          $this->do_vote($poll_id, $_REQUEST['fmypolls_results'], $_REQUEST['fmypolls_comment'], $user['user_id'], $_SERVER['REMOTE_ADDR'],  $user['language']);
        }
        
        $this->display_page($poll_id);
      }
    }

    /*
      initialise menubar's menu
      called by menubar object when making menu
    */
    function manage_menu()
    {
      global $user;

      if($user_id==2) { $vote_id = $_SERVER['REMOTE_ADDR']; } else { $vote_id = $user_id; }
      $polls_list=$this->get_polls_list($vote_id, is_admin(), $user['language']);
      $menu_list=array();
      foreach($polls_list as $key => $val)
      {
        $nfo="";
        if($val['enabled']=='n')
        { $nfo.='<i>['.l10n('mypolls_menu_not_enabled').']</i>'; }
        if($val['visible']=='n')
        { $nfo.='<i>['.l10n('mypolls_menu_not_visible').']</i>'; }
        if($val['public_results']=='n')
        { $nfo.='<i>['.l10n('mypolls_menu_not_publicr').']</i>'; }
        array_push($menu_list,
          array(
            'text' => $nfo.$val['title'],
            'link' => './index.php?/'.$this->section_name.'/'.$val['id'],
            'id' => $val['id']
          )
        );
      }
      $this->menubar->set_menu_list($menu_list);
      $this->menubar->set_menu_title($this->my_config['mypolls_menubar_title'][$user['language']]);
      $this->menubar->set_lnk_admin_add(l10n('mypolls_admin_add'),
                                          PHPWG_ROOT_PATH.$this->page_link.'&amp;f_tabsheet=polls&amp;action=create');
      $this->menubar->set_lnk_admin_edit(l10n('mypolls_admin_edit'),
                                          PHPWG_ROOT_PATH.$this->page_link."&amp;f_tabsheet=polls&amp;action=modify&amp;fmypolls_att_id=");
    }


  /* ---------------------------------------------------------------------------
     ajax functions
  --------------------------------------------------------------------------- */
    /*
      return ajax content if request is ajax else return nothing (script allowed to continue)
    */
    function return_ajax_content()
    {
      global $user, $ajax;

      if(isset($_REQUEST['ajaxfct']))
      {


        $poll_id=$this->extract_poll_id_from_uri();
        //$user['language'] = $_REQUEST['lang'];
        switch($_REQUEST['ajaxfct'])
        {
          case 'poll_question_blocks':
            if($user['language']=='')
            {
              $user['language']=$_REQUEST['lang'];
            }
            $this->load_lang();
            $result=$this->ajax_poll_question_blocks($poll_id, $_REQUEST['question'], $_REQUEST['lang']);
            break;
          case 'poll_comment_list':
            $result=$this->ajax_poll_comment_list($poll_id, $_REQUEST['vpage']);
            break;
        }


       $this->ajax->return_result($result);
      }
    }

  function ajax_poll_question_blocks($poll_id, $question_num, $lang)
  {
    $local_tpl = new Template(MYPOLLS_PATH."templates/", "");
    $local_tpl->set_filename('body_page',
                  dirname($this->filelocation).'/templates/mypolls_public_question2.tpl');


    $poll_values=$this->get_poll_values($poll_id, $lang);
    $poll_questions=$this->get_poll_questions($poll_id, "", $lang);
    $numq=1;
    foreach($poll_questions as $key => $val)
    {
      if(($question_num==0)||($numq==$question_num))
      {
        $ansnfo="";
        switch($val['question_type'])
        {
          case 'multi':
            $ansnfo=sprintf(l10n('mypolls_answer_maxi'), $val['multi_max_answers']);
            break;
          case 'order':
            $ansnfo=l10n("mypolls_answer_order");
            break;
        }
        $local_tpl->assign_block_vars(
          'mypolls_questions_block',
          array(
            'NUMQ' => $numq,
            'NBQ' => $poll_values['nb_questions'],
            'DESCRIPTION' => html_entity_decode($val['description']),
            'ANSNFO' => $ansnfo
          )
        );

        $poll_answers=$this->get_poll_answers($poll_id, $val['question_num'], $lang);
        foreach($poll_answers as $key2 => $val2)
        {
          $inputfield="";
          switch($val['question_type'])
          {
            case 'mono':
              $inputfield="<input type='radio' name='fq_".$val['question_num']."'
                            id='iq_".$val['question_num']."_a_".$val2['answer_num']."' 
                            value='".$val2['answer_num']."'
                            onclick='check_mono(\"fq_".$val['question_num']."\", ".$numq.")' > ";
              break;
            case 'multi':
              $inputfield="<input type='checkbox' name='fq_".$val['question_num']."'
                            id='iq_".$val['question_num']."_a_".$val2['answer_num']."' 
                            value='".$val2['answer_num']."'
                            onclick='check_multi(".$val['multi_max_answers'].", \"fq_".$val['question_num']."\", ".$numq.")' >";
              break;
            case 'order':
              $inputfield="<select name='fq_".$val['question_num']."'
                            id='iq_".$val['question_num']."_a_".$val2['answer_num']."' 
                            onchange='check_order(\"fq_".$val['question_num']."\", ".$numq.", \"iq_".$val['question_num']."_a_".$val2['answer_num']."\")' >";
              $inputfield.="<option value='-'>-</option>";
              for($i=1;$i<=count($poll_answers);$i++)
              {
                $inputfield.="<option value='$i'>$i</option>";
              }
              $inputfield.="</select>";
              break;
          }

          $local_tpl->assign_block_vars(
            'mypolls_questions_block.answers',
            array(
              'INPUTFIELD' => $inputfield,
              'ANSWER' => html_entity_decode($val2['answer'])
            )
          );
        }
      }
      $numq++;
    }

    if(($question_num==$poll_values['nb_questions'])||($question_num==0))
    {
      if($poll_values['allow_comment']=='y')
      {
        $local_tpl->assign_block_vars('mypolls_last_question.comment', array());
      }
      else
      {
        $local_tpl->assign_block_vars('mypolls_last_question', array());
      }
    }
    else
    {
      $local_tpl->assign_block_vars(
        'mypolls_next_question',
        array('NEXTQUESTION' => $question_num+1)
      );
    }

    return($local_tpl->parse('body_page', true));
  }

  } //class




?>
